; Tunnel v1.2 by Joe Wingbermuehle

.nolist
#include	"joeti83.inc"
#include	"sos.inc"


first		=sram
width		=sram+1
car		=sram+2
ovrflg		=sram+3
score		=sram+4
count		=sram+6
count2		=sram+7

.org	$9327
.list

	xor	a
	jr	z,start_of_program
	.dw	libraries-$9327
	.dw	description
start_of_program:
	ld	a,30
	ld	(first),a
	ld	a,35
	ld	(width),a
	ld	a,40
	ld	(car),a
	sbc	hl,hl		; I use a xor a instead of ccf at the beginning
	ld	(ovrflg),hl
	ld	(score+1),hl
	ld	(count2),hl
	ld	hl,770
	ld	(currow),hl
	ld	hl,abt1
	call	puts
	ld	de,1283
	ld	(currow),de
	call	puts
	ld	de,516
	ld	(currow),de
	call	puts
	ld	hl,7
	ld	(currow),hl
	ld	hl,abt4
	call	puts
	ld	hl,2567
	ld	(currow),hl
	ld	hl,(high_score)
	call	disphl
	call	wkey
	call	drwcar
	ld	bc,7680
	ld	d,b
	ld	e,63
	call	dark_line
	ld	bc,16640
	ld	d,b
	call	dark_line

;-----> The main game loop
main:	ld	a,(ovrflg)
	or	a
	jp	nz,gmovr
	ld	a,(count)
	sub	10
	jr	nz,skp1
	ld	(count),a
	ld	hl,(score)
	inc	hl
	ld	(score),hl
	ld	hl,count2
	inc	(hl)
	ld	a,(hl)
	sub	20
	jr	nz,skp1
	ld	hl,width
	dec	(hl)
	ld	(count2),a
skp1:	call	vector2
	ei	; get those interrupts a'mess'in up r!

; Move down
	call	drwcar
	ld	hl,count
	inc	(hl)
	ld	de,911Dh	; scrolling begins
	ld	hl,9111h
	ld	bc,02F4h
	lddr			; scrolling ends!
	ld	a,r
	rra
	and	3
	jr	nz,move1
	ld	a,(first)
	dec	a
	jr	z,mdc1
	jr	mdone
move1:	dec	a
	jr	nz,mdc1
	ld	a,(first)
	cp	59
	jr	z,mdc1
	inc	a
mdone:	ld	(first),a
mdc1:	ld	b,12
	ld	hl,gbuf
	xor	a
mdlp1:	ld	(hl),a
	inc	hl
	djnz	mdlp1
	ld	a,(first)
	ld	hl,gbuf
	call	vector1
	ld	(hl),a
	ld	a,(first)
	ld	hl,width
	add	a,(hl)
	ld	hl,gbuf
	call	vector1
	ld	(hl),a
	call	drwcar
; Check for collision
	ld	a,(car)
	ld	hl,gbuf+(53*12)
	call	vector1
	and	(hl)
	jr	z,flagit
	ld	hl,gbuf+(53*12)
	ld	a,(car)
	add	a,6
	call	vector1
	and	(hl)
	jr	nz,cn2
flagit:	ld	a,1
	ld	(ovrflg),a
cn2:
; Get input
	ld	a,0FFh
        out	(1),a
	ld	a,0FEh
        out	(1),a
	in	a,(1)
	cp	253
	jr	z,mleft
	cp	251
	jr	z,mright
	ld	a,0BFh
	out	(1),a
	in	a,(1)
	cp	191
	jr	z,pause
        cp	127
	jp	nz,main
gmovr:	call	clrscr
	ld	hl,770
	ld	(currow),hl
	ld	hl,gover
	call	puts
	ld	hl,515
	ld	(currow),hl
	ld	hl,scr
	call	puts
	ld	hl,(score)
	call	disphl
	ld	hl,(score)
	ex	de,hl
	ld	hl,(high_score)
	call	cphlde
	call	c,newhs
	jp	wkey

newhs:	ex	de,hl
	ld	(high_score),hl
	ld	hl,261
	ld	(currow),hl
	ld	hl,nhs
	jp	putps

mright:	call	drwcar
	ld	a,(car)
	inc	a
	cp	87
	jr	mlpx

mleft:	call	drwcar
	ld	a,(car)
	dec	a
mlpx:	jr	z,mlx
	ld	(car),a
mlx:	call	drwcar
	jp	main

pause:	call	wkey
	jp	main

wkey:	call	wrel
wkey2:	call	getk
	or	a
	jr	z,wkey2
wrel:	call	getk
	or	a
	jr	nz,wrel
	ret

drwcar:	ld	ix,cars
	ld	l,50
	ld	a,(car)
	ld	b,4
	jp	vector0

cars:	.db	%00010000
	.db	%00111000
	.db	%01101100
	.db	%11000110

gover:	.db	"Game Over",0
description:
abt1:	.db	"Tunnel v1.3",0
abt2:	.db	"by Joe",0
abt3:	.db	"Wingbermuehle",0
nhs:	.db	13,"New "
abt4:	.db	"High"
scr:	.db	"Score:",0

libraries:
	.db	"ZLIB",0
high_score:			; I'm allowed to a trick or two don't you think?
	.db	0,0,0,lib1,vec0	; sprite
	.db	"ZLIB",0,0,0,0,lib3,vec1	; getbit
	.db	"ZGFXL",0,0,0,lib2,vec2		; fastCopy
	.db	$FF

.end
END
